SystemOrganization addCategory: #TusLibros!

TestCase subclass: #TusLibrosTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!TusLibrosTest methodsFor: 'Cart Instances' stamp: 'JuanManuelTastzian 5/29/2013 18:23'!
emptyCart
	^Cart newEmptyCart! !

!TusLibrosTest methodsFor: '1 - Cart Test' stamp: 'JuanManuelTastzian 5/29/2013 20:01'!
test1CartShouldBeEmptyAfterCreation
	self assert: self emptyCart isEmpty! !

!TusLibrosTest methodsFor: '1 - Cart Test' stamp: 'JuanManuelTastzian 5/29/2013 20:05'!
test2CartSizeShouldBeGreaterThan0AfterAddingABookToIt
	| cart book |
	cart := Cart newEmptyCart.
	book := 'aBook'.
	cart add: book.
	self assert: (cart size > 0).! !

!TusLibrosTest methodsFor: '1 - Cart Test' stamp: 'JuanManuelTastzian 5/29/2013 20:24'!
test3aBookShouldBeListedAfterBeingAddedToACart
	| cart book |
	cart := Cart newEmptyCart.
	book := 'aBook'.
	cart add: book.
	self assert: (cart includes: book)! !

!TusLibrosTest methodsFor: '1 - Cart Test' stamp: 'JuanManuelTastzian 5/29/2013 20:24'!
test4aCartHasOnlyOneBookAfterAddingABookToAnEmptyCart
	| cart book |
	cart := Cart newEmptyCart.
	book := 'aBook'.
	cart add: book.
	self assert: (cart includes: book).
	self assert: cart size = 1! !

!TusLibrosTest methodsFor: '1 - Cart Test' stamp: 'JuanManuelTastzian 5/29/2013 20:25'!
test5aBookCanBeAddedMoreThanOnce
	| cart book anotherBook |
	
	cart := Cart newEmptyCart.
	book := 'Un libro que no es una clase'.
	anotherBook := 'Otro libro que no es una clase'.
	
	cart add: book.
	cart add: book.
	cart add: anotherBook.
	
	self assert: (cart includes: book).
	self assert: cart size = 3.
	self assert: (cart numberOfUnitsAddedOf: book) = 2.
	self assert: (cart numberOfUnitsAddedOf: anotherBook) = 1.! !

!TusLibrosTest methodsFor: '1 - Cart Test' stamp: 'JuanManuelTastzian 5/29/2013 20:35'!
test6booksThatAreNotOnTheCatalogCantBeAddedToCart
	| cart book |
	
	cart := Cart newEmptyCart.
	book := 'aBook'.
	
	cart add: book.
	
	self deny: (cart includes: book).
	self assert: cart isEmpty.! !

!TusLibrosTest methodsFor: '1 - Cart Test' stamp: 'JuanManuelTastzian 5/29/2013 20:39'!
test7onlyBooksFromCatalogCanBeAddedToCart
	| cart book catalog |
	
	book := 'aBook'.
	catalog := Bag new.
	catalog add: book.
	cart := Cart withCatalog: catalog.
	
	cart add: book.
	
	self assert: (cart includes: book).
	self assert: cart size = 1.! !

Object subclass: #Cart
	instanceVariableNames: 'size books catalog'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

Cart class
	instanceVariableNames: 'size'!

Cart class
	instanceVariableNames: 'size'!

!Cart class methodsFor: 'class initialization' stamp: 'JuanManuelTastzian 5/29/2013 18:30'!
newEmptyCart
	^self new withoutBooks! !

!Cart class methodsFor: 'class initialization' stamp: 'JuanManuelTastzian 5/29/2013 20:41'!
withCatalog: aCatalog 
	^ self new catalog: aCatalog.! !

!Cart methodsFor: 'accessing' stamp: 'JuanManuelTastzian 5/29/2013 20:36'!
add: aBook 
	(catalog includes: aBook) ifTrue: [books add: aBook]! !

!Cart methodsFor: 'accessing' stamp: 'JuanManuelTastzian 5/29/2013 18:36'!
books
	^ books! !

!Cart methodsFor: 'accessing' stamp: 'JuanManuelTastzian 5/29/2013 20:43'!
catalog: aCatalog 
	books := Bag new.
	catalog := aCatalog.! !

!Cart methodsFor: 'accessing' stamp: 'JuanManuelTastzian 5/29/2013 19:16'!
includes: aBook 
	^books includes: aBook! !

!Cart methodsFor: 'accessing' stamp: 'JuanManuelTastzian 5/29/2013 20:04'!
isEmpty
	^ self size = 0! !

!Cart methodsFor: 'accessing' stamp: 'JuanManuelTastzian 5/29/2013 19:26'!
numberOfUnitsAddedOf: aBook 
	^(books occurrencesOf: aBook)! !

!Cart methodsFor: 'as yet unclassified' stamp: 'JuanManuelTastzian 5/29/2013 18:38'!
size
	^books size! !

!Cart methodsFor: 'accessing' stamp: 'JuanManuelTastzian 5/29/2013 20:27'!
withoutBooks
	books := Bag new.
	catalog := Bag new.! !
